//@author: vux
//@help: template for standard shaders
//@tags: template
//@credits: 

Texture2D tex0 <string uiname="Texture";>;

SamplerState s0 : IMMUTABLE
{
    Filter = MIN_MAG_MIP_POINT;
    AddressU = Clamp;
    AddressV = Clamp;
};
 
float4x4 tVP : LAYERVIEWPROJECTION;	
float4x4 tW : WORLD;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
};

struct vs2ps
{
    float4 pos: SV_Position;
    float4 uv: TEXCOORD0;
};

vs2ps VS(VS_IN input)
{
    vs2ps output;
	
	float4 world = tex0.SampleLevel(s0, input.uv.xy, 0);
	
    output.pos  = mul(input.pos + world,mul(tW,tVP));
    output.uv = input.uv;
    return output;
}

float4 PS(vs2ps input): SV_Target
{
    float4 col = tex0.Sample(s0,input.uv.xy);
    return col;
}

technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




