//@author: vux
//@help: template for standard shaders
//@tags: template
//@credits: 

Texture2D tex0 <string uiname="Texture";>;

SamplerState s0 
{
    Filter = MIN_MAG_MIP_POINT;
    AddressU = Clamp;
    AddressV = Clamp;
};
 
float4x4 tVP : LAYERVIEWPROJECTION;	
float4x4 tW : WORLD;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
	uint ii : SV_InstanceID;
};

struct vs2ps
{
    float4 pos: SV_Position;
    float4 uv: TEXCOORD0;
};

float2 R;
float4x4 tKinectWorld;

float StepSize = 16;


vs2ps VS(VS_IN input)
{
    vs2ps output;
	
	float2 uv = float2 ((1 / R.x * input.ii), ceil(input.ii / R.x) * (1 / R.y)); 
	
	float4 world = tex0.SampleLevel(s0, uv.xy, 0);
	world = mul ( float4 (world.xyz, 1) , tKinectWorld);
	
	world.x = ceil ( world.x  * StepSize) / StepSize;
	world.y = ceil ( world.y  * StepSize) / StepSize;
	world.z = ceil ( world.z  * StepSize) / StepSize;
	
	
	
    output.pos  = mul(input.pos + world,mul(tW,tVP));
    
	output.uv = float4 (uv,0,1);
    return output;
}

float4 PS(vs2ps input): SV_Target
{
    
	float4 col = tex0.SampleLevel(s0,input.uv.xy, 0);
	
    return col;
}

technique10 Constant
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




